various bug fixes
[distro-setup] / check-subvol-stale
index 1451844f7c89298d2a9e100eeabba7f837874d24..6a63124cd3ac749028a794117e0da2df384dbcfd 100644 (file)
@@ -14,8 +14,6 @@
 # limitations under the License.
 
 
-# if latest subvols $@ are not mounted, exit 1, print message, and touch /nocow/btrfs-stale/$subvol
-
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
 
 set -eE -o pipefail
@@ -23,53 +21,166 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 shopt -s nullglob
 
+usage() {
+  cat <<EOF
+usage: $0 SUBVOL_MOUNTPOINT...
+
+In git this is not not executable because it's meant to be installed
+using ./install-my-scripts
+
+If latest subvols \$@ are not mounted, exit 1, print message, and print
+the unstale subvol name into /nocow/btrfs-stale/\$subvol
+
+Fresh is opposite of stale. To be fresh, either SUBVOL_MOUNTPOINT is a
+snapshot of the latest, or the latest snapshot is snapshot of
+SUBVOL_MOUNTPOINT.
+
+-d         Enable debug output
+-h|--help  Print help and exit.
+
+Note: Uses GNU getopt options parsing style
+EOF
+  exit $1
+}
+
+##### begin command line parsing ########
+
+debug=false # default
+temp=$(getopt -l help,d hd "$@") || usage 1
+eval set -- "$temp"
+while true; do
+  case $1 in
+    -d) debug=true; shift ;;
+    -h|--help) usage ;;
+    --) shift; break ;;
+    *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
+  esac
+done
+
 if [[ ! $@ ]]; then
     echo "$0: error: expected mountpoint argument"
 fi
 
+stale-file() {
+    stale_dir=/nocow/btrfs-stale
+    stale_file=$stale_dir/$vol
+    if $stale; then
+        mkdir -p $stale_dir
+        printf "%s\n" $freshest_snap > $stale_file
+        ret=1
+    else
+        rm -f $stale_file
+    fi
+
+}
+d() {
+  if $debug; then
+    printf "%s\n" "$*"
+    fi
+}
+
 ret=0
 for d; do
     vol=${d##*/}
-    cd /mnt/root/btrbk
-    snaps=($vol.20*)
+    # second field, non-comment line == $d
+    dev=$(sed -rn "s,^\s*([^#]\S*)\s+$d\s.*,\1,p" /etc/fstab /etc/mtab|head -n1)
+    d dev=$dev
+    subvol_dir=$(sed -rn "s,^\s*[^#]\S*\s+$d\s.*\bsubvol=([a-zA-A/]+).*,\1,p" /etc/fstab /etc/mtab|head -n1)
+    d subvol_dir=$subvol_dir
+    # note, we need $dev because $d might not be mounted, and we do this loop
+    # because the device in fstab for the rootfs can be different.
+    for devx in $(btrfs fi show $dev| sed -rn 's#.*path (/\S+)$#\1#p'); do
+        root_dir=$(sed -rn "s,^\s*$devx\s+(\S+).*\bsubvolid=[05]\b.*,\1,p" /etc/mtab|head -n1)
+        if [[ $root_dir ]]; then break; fi
+    done
+    if [[ ! $root_dir ]]; then
+      echo "$0: error could not find root subvol mount for $dev" >&2
+      exit 1
+    fi
+    svp=$root_dir/$subvol_dir
+    d "svp=$svp # subvolume path"
+
+    snaps=($root_dir/btrbk/$subvol_dir.20*) # Assumes we are in the 21st century.
     if [[ ! $snaps ]]; then
         # no snapshots yet
+      echo "$0: warning: no snapshots found at $root_dir/btrbk/$subvol_dir.20*. this is expected for a brand new volume"
         continue
     fi
+
+    # get info on last received sub
+    last_received_cgen=0
+    for f in ${snaps[@]}; do
+        show="$(btrfs sub show $f)"
+        if echo "$show" | grep -E "Received UUID:\s+[[:alnum:]]" &>/dev/null; then
+            cgen=$(echo "$show" | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
+            if [[ $cgen -gt $last_received_cgen ]]; then
+                last_received_cgen=$cgen
+                last_received=$f
+            fi
+        fi
+    done
+    d last_received_cgen=$cgen
+    d last_received=$f
+
+    # Get last_snap by date.
     # when a btrbk bugfix makes it into the distro,
     # we might replace this with btrbk list latest /mnt/root/$vol | ...
-    # note: this is duplicated in mount-latest-subvol
     last_snap=$(
-        for f in ${snaps[@]}; do
-            printf "%s %s\n" $(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${f#$vol.}) +%s) $f
+        for s in ${snaps[@]}; do
+            f=${s##*/}
+            unix_time=$(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${f#$vol.}) +%s)
+            printf "%s %s\n" $unix_time $s
         done | sort -r | head -n 1 | awk '{print $2}'
              )
     if [[ ! $last_snap ]]; then
-        echo "$d stale"
+        # should not happen.
+        echo "$0: error: could not find latest snapshot for $svp among ${snaps[*]}"
         ret=1
         continue
     fi
+
+    if [[ ! -e $svp ]]; then
+        echo "$0: warning: subvol does not exist: $svp"
+        echo "$0 assuming this host was just for receiving and latest snap is freshest"
+        freshest_snap=$last_snap
+        stale=true
+        stale-file
+        continue
+    fi
+
+
+    # if there is a last_received, we can assume stale or fresh if we are newer/older
+    if [[ $last_received ]]; then
+        svp_cgen=$(btrfs sub show $svp | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
+        d svp_cgen=$svp_cgen
+        if [[ $svp_cgen -ge $last_received_cgen ]]; then
+            stale=false
+        else
+            echo "$svp stale: it's gen at creation, $svp_cgen, is earlier than the last received snapshot, $last_received's gen at creation: $last_received_cgen"
+            freshest_snap=$last_received
+            stale=true
+        fi
+        stale-file
+        continue
+    fi
+
+    # fallback to using last_snap as the freshest
+    freshest_snap=$last_snap
     stale=true
-    if btrfs sub show $d|sed '0,/^\t*Snapshot(s):/d;s/^\s*//' | \
+    # fresh if $svp has $last_snap as a snapshot,
+    if btrfs sub show $svp 2>/dev/null | sed '0,/^\s*Snapshot(s):/d;s/^\s*//' | \
             grep -xF btrbk/$last_snap &>/dev/null; then
         stale=false
-    else
-        last_uuid=$(btrfs sub show $last_snap| awk '$1 == "UUID:" {print $2}')
-        if btrfs sub show $d| grep "^\s*Parent UUID:\s*$last_uuid$" &>/dev/null; then
+    else # or else $svp is a snapshot of $last_snap. we use a uuid
+        # comparison, which if I remember from the docs, is a bit more
+        # robust, perhaps to renames.
+        last_snap_uuid=$(btrfs sub show $last_snap| awk '$1 == "UUID:" {print $2}')
+        if btrfs sub show $svp| grep "^\s*Parent UUID:\s*$last_snap_uuid$" &>/dev/null; then
             stale=false
         fi
     fi
-    stale_dir=/nocow/btrfs-stale
-    stale_file=$stale_dir/$vol
-    if $stale; then
-        mkdir -p $stale_dir
-        printf "%s\n" $last_snap > $stale_file
-        echo "$d stale"
-        ret=1
-        continue
-    else
-        rm -f $stale_file
-    fi
+
+    stale-file
+
 done
 exit $ret
-